# How to add YANG Models

## Adding the YANG Model Files

All yang models used for the process of compiling the corresponding go code are stored under the directory <code>models</code>. 

There is a logical separation in the gnmi-target for the models:
- <code>models/openconfig</code>: contains the OpenConfig yang models. This is a git submodule of https://github.com/openconfig/public/tree/master/
- <code>models/YangModels</code>: contains the models of various standardization organisations. This is git submodule of https://github.com/YangModels/yang

You can add other or your own yang models directly under models or within a subdirectory below models, as done for the above two mentioned. 

## Including the YANG Models for YGOT

The file <code>modeldata/gnmitargetygot/config.yaml</code> defines which yang models should be compiled through ygot go code.

TODO: more details about the yaml file. 

## Generate Code out of YANG Models

We rely on [ygot](https://github.com/openconfig/ygot) to generate go code out of the yang models. 

### First time usage
You have to fetch the openconfig and YangModel submodule data first by this:
- <code>git submodule init</code>
- <code>git submodule update</code>

These commands ensure that the git submodules are filled with the repositories' content.  

### Generate Code

Use the Makefile to generate go code:
<code>make generate-yang-models</code>


### Errors 
TODO: discuss errors of the generation process

## Adding the Functionality to the Target

TODO: describe how to make use out of the generated got code and how to integrate it to the gnmi-target. 
