package additions

import "time"

type Interfaces interface {
	GetInterfaces() ([]*Interface, error)
	SetInterface(*Interface) error
	SubscribeToInterfaces() (chan *Interface, error)
}

type System interface {
	GetHostname() (string, error)
	SetHostname(hostname *string) error
	GetCurrentTime() time.Time
	GetTimeZoneName() string
	GetTotalMemory() uint64
	GetFreeMemory() uint64
	GetUsedMemory() uint64
	GetDomainName() (string, error)
	GetMotd() (string, error)
	SetMotd(message string) error
	// yang: leaf software-version
	GetSoftwareVersion() (string, error)
}

type NetworkInstances interface {
	SetStaticRoute(*StaticRoute) error
	GetStaticRoutes(linkName string) ([]*StaticRoute, error)
}
